<?php
function print_anything_settings_export() {
  $settings = array();
  $settings['print_anything_footer'] = variable_get('print_anything_footer', null);
  $settings['print_anything_header'] = variable_get('print_anything_header', null);
  $settings['print_anything_link_text'] = variable_get('print_anything_link_text', null);
  $settings['print_anything_include_wrappers'] = variable_get('print_anything_include_wrappers', null);

  $table_print_anything = db_select('print_anything', 'p')
    ->fields('p')
    ->execute()->fetchAll();

  $table_print_anything_paths = db_select('print_anything_paths', 'p')
    ->fields('p')
    ->execute()->fetchAll();

  $export = array(
    'settings' => $settings,
    'table_print_anything' => $table_print_anything,
    'table_print_anything_paths' => $table_print_anything_paths,
  );

  $output = drupal_get_form('print_anything_settings_export_form', serialize($export));
  return $output;
}

function print_anything_settings_export_form($form, &$form_state, $export) {
  $value = print_r($export, TRUE);
  $form = array();
  $form['export'] = array(
    '#type' => 'textarea',
    '#title' => 'Export',
    '#description' => 'Exports all of the settings EXCEPT for the header image and image style. These you have to bring over manually. Paste this code into the import window.',
    '#value' => $value,
  );
  return $form;
}

function print_anything_settings_import_form($form, &$form_state) {
  $form = array();
  $form['import'] = array(
    '#type' => 'textarea',
    '#title' => 'Import',
    '#description' => 'Paste the code generated by export feature here.',
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Import'),
  );
  return $form;
}

function print_anything_settings_import_form_submit($form, &$form_state) {
  $import = unserialize($form_state['values']['import']);
  // Dump the current tables
  db_delete('print_anything')->execute();
  db_delete('print_anything_paths')->execute();

  // Import the data for the table "print_anything"
  foreach($import['table_print_anything'] as $row) {
    $query = db_insert('print_anything')
      ->fields(array(
        'rid' => $row->rid,
        'pid' => $row->pid,
        'css_id' => $row->css_id,
        'weight' => $row->weight,
      ))
      ->execute();
  }

  // Import the data for the table "print_anything_paths"
  foreach($import['table_print_anything_paths'] as $row) {
    $query = db_insert('print_anything_paths')
      ->fields(array(
        'pid' => $row->pid,
        'path' => $row->path,
        'weight' => $row->weight,
      ))
      ->execute();
  }

  // Import the basic settings
  foreach($import['settings'] as $key => $value) {
    variable_set($key, $value);
  }
  $form_state['redirect'] = PRINT_ANYTHING_ADMINPATH . '/paths';
  drupal_set_message('The import has been completed.', 'status');
  watchdog('print_anything', 'Configuration settings were imported.', null, WATCHDOG_INFO);
}